import 'dart:io';

import 'package:path/path.dart';

import 'src/local_machine.dart';
import 'src/remote/machine_client.dart';
import 'src/remote/machine_server.dart';

class GazaMachine {
  /// Create new machine.
  static Future<MachineServer> create(
      [int port = 0, String? pMachineDir]) async {
    pMachineDir ??= join(Directory.current.path, "machine_data");
    final server = MachineServer(port, pMachineDir);
    await server.start();
    return server;
  }

  /// Connect to a machine
  static MachineClient connect(int port, [String? ip]) =>
      MachineClient(port, ip);

  /// Create a local machine.
  static LocalMachine localMachine([String? machineDir]) {
    machineDir ??= join(Directory.current.path, "machine_data");
    return LocalMachine(machineDir);
  }
}
