#!/usr/bin/env python3
from genericpath import exists
from os import chdir, makedirs, system
from os.path import abspath, dirname, join
from sys import stdout

def echo(message):
    stdout.write(message)
    stdout.flush()

THIS_DIR = dirname(abspath(__file__))
DART_PACKAGE_DIR = dirname(THIS_DIR)
PROTO_DIR = join(DART_PACKAGE_DIR, "proto")
OUTPUT_DIR = join(DART_PACKAGE_DIR, "lib/src/generated/grpc/machine")

if not exists(OUTPUT_DIR): makedirs(OUTPUT_DIR)

echo("Generate gRPC... ")
c = system(f"protoc -I={PROTO_DIR} --dart_out=grpc:{OUTPUT_DIR} machine.proto")
if c != 0: 
    echo("Error!\n")
    exit(c)
echo("Done.\n")


echo("Better grpc generator... \n")
chdir(DART_PACKAGE_DIR)
c = system(f"dart run build_runner build")
if c != 0: 
    echo("Error!\n")
    exit(c)
echo("Done.\n")