import 'package:gaza_machine/gaza_machine.dart';
import 'package:gaza_machine/src/generated/grpc/machine/machine.pbgrpc.dart';
import 'package:test/test.dart';

void main() {
  test('get current os', () async {
    final localMachine = GazaMachine.localMachine();
    final machineServer = await GazaMachine.create(8000);
    final machineClient = machineServer.client;

    final localOS = await localMachine.system.getOS(Empty());
    final serverOS = await machineClient.system.getOS(Empty());

    print("The local machine os is $localOS");
    print("The virtual machine os is $serverOS");

    if (localOS != serverOS) {
      throw Exception("The two machines aren't the same!");
    }
  });

  test('get current architecture', () async {
    final localMachine = GazaMachine.localMachine();
    final arch = await localMachine.system.getArch(Empty());
    print("The current architecture is: ${arch.arch}");
  });
}
